;  Written by Four-F (four-f@mail.ru)

.386
.model flat, stdcall
option casemap:none

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                  I N C L U D E   F I L E S                                        
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

include \masm32\include\windows.inc

include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib

include \masm32\cocomac\cocomac.mac
include \masm32\cocomac\Animate.mac

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                        M A C R O S                                                
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

date MACRO
	% FORC chr, @Date
		db "&chr"
	ENDM
ENDM

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                         F U N C T I O N S   P R O T O T Y P E S                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgProc proto :HWND, :UINT, :WPARAM, :LPARAM

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                     C O N S T A N T S                                             
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.const
IDD_DIALOG		equ		1000
IDM_MAIN		equ		1001
IDM_150			equ		150
IDM_166			equ		166
IDM_ABOUT		equ		1002
IDI_ICON		equ		2000
IDC_ANIMATE		equ		3000

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              I N I T I A L I Z E D  D A T A                                       
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.data
szShell32LibName	db "\\shell32.dll", 0
szAbout				db "About...", 0
szWrittenBy			db "Written by Four-F ("
					date
					db ")", 0Ah, 0Dh, "four-f@mail.ru", 0

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              U N I N I T I A L I Z E D  D A T A                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.data?
g_hInstance		HINSTANCE	?
g_hMenu			HMENU		?
g_hwndAnim		HWND		?
g_hinstShellLib	HINSTANCE	?

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                       C O D E                                                     
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.code

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                 D I A L O G      P R O C E D U R E                                
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgProc proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL buffer[MAX_PATH]:BYTE
LOCAL rect:RECT
LOCAL hSysMenu:HMENU

	mov eax, uMsg
	.if eax == WM_INITDIALOG

		; Set Dialog Icon
		invoke LoadIcon, g_hInstance, IDI_ICON
		invoke SendMessage, hDlg, WM_SETICON, ICON_BIG, eax

		invoke LoadMenu, g_hInstance, IDM_MAIN
		mov g_hMenu, eax
		invoke SetMenu, hDlg, g_hMenu

		Animate_Create hDlg, IDC_ANIMATE, ACS_AUTOPLAY + ACS_CENTER + ACS_TRANSPARENT + WS_CHILD + WS_VISIBLE, g_hInstance
		mov g_hwndAnim, eax

		invoke GetClientRect, hDlg, addr rect
		invoke SetWindowPos, g_hwndAnim, 0, rect.left, rect.top, rect.right, rect.bottom, SWP_NOZORDER + SWP_DRAWFRAME

		invoke GetSystemDirectory, addr buffer, MAX_PATH
		invoke lstrcat, addr buffer, addr szShell32LibName
		invoke LoadLibrary, addr buffer
		mov g_hinstShellLib, eax

		invoke GetMenu, hDlg
		mov ecx, eax
		invoke InsertMenu, ecx, -1, MF_BYPOSITION + MF_STRING, IDM_ABOUT, offset szAbout		

		invoke GetSystemMenu, hDlg, FALSE
		mov hSysMenu, eax
		invoke InsertMenu, hSysMenu, -1, MF_BYPOSITION + MF_SEPARATOR, 0, 0
		invoke InsertMenu, hSysMenu, -1, MF_BYPOSITION + MF_STRING, IDM_ABOUT, offset szAbout

	.elseif eax == WM_COMMAND

		mov eax, wParam
		and eax, 0FFFFh
		.if eax == IDCANCEL
			invoke EndDialog, hDlg, 0
		.elseif ( eax >= IDM_150 ) && ( eax <= IDM_166 )
			push eax
			Animate_Close g_hwndAnim
			invoke InvalidateRect, g_hwndAnim, NULL, TRUE
			pop eax
			Animate_OpenEx g_hwndAnim, g_hinstShellLib, eax
		.elseif wParam == IDM_ABOUT
			invoke MessageBox, hDlg, addr szWrittenBy, addr szAbout, MB_OK + MB_ICONINFORMATION
		.endif

	.elseif eax == WM_SYSCOMMAND
		.if wParam == IDM_ABOUT
			invoke PostMessage, hDlg, WM_COMMAND, IDM_ABOUT, 0
		.endif
 		xor eax, eax
 		ret

	.elseif eax == WM_DESTROY
		Animate_Close g_hwndAnim
		invoke DestroyWindow, g_hwndAnim
		invoke FreeLibrary, g_hinstShellLib

	.else

 		xor eax, eax
 		ret
      
	.endif

	xor eax, eax
	inc eax
	ret   
    
DlgProc endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

start:
	invoke GetModuleHandle, NULL
	mov g_hInstance, eax
	invoke DialogBoxParam, g_hInstance, IDD_DIALOG, NULL, addr DlgProc, 0
	invoke ExitProcess, eax
    invoke InitCommonControls
end start
