; Based on articles published on GodeGhuru
; Written by Four-F (four-f@mail.ru)

.386
.model flat, stdcall
option casemap:none

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                  I N C L U D E   F I L E S                                        
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

include \masm32\include\windows.inc

include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

include \masm32\cocomac\cocomac.mac
include \masm32\cocomac\ListView.mac
include \masm32\cocomac\Header.mac

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                         F U N C T I O N S   P R O T O T Y P E S                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgProc proto :HWND, :UINT, :WPARAM, :LPARAM

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                        M A C R O S                                                
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

$invoke MACRO vars:VARARG
     invoke vars
     EXITM <eax>
ENDM

m2m MACRO Des:REQ, Sor:REQ
    push Sor
	pop  Des		
ENDM

$LOWORD MACRO dwVar:REQ
	IF $IsImm(dwVar)
		EXITM <dwVar AND 0FFFFh>
	ELSE
		IFDIFI <dwVar>, <eax>	;; don't move eax onto itself
			mov eax, dwVar
		ENDIF
		and eax, 0FFFFh
		EXITM <eax>
	ENDIF
ENDM

$HIWORD MACRO dwVar:REQ
	IF $IsImm(dwVar)
		EXITM <dwVar SHR 16>
	ELSE
		IFDIFI <dwVar>, <eax>	;; don't move eax onto itself
			mov eax, dwVar
		ENDIF
		shr eax, 16
		EXITM <eax>
	ENDIF
ENDM

$TA0 MACRO sText
local szDummy
	.data
	IFNB <sText>
		szDummy db sText, 0
	ELSE
		szDummy db 0
	ENDIF
	.code
	EXITM <offset szDummy>
ENDM

date MACRO
	% FORC chr, @Date
		db "&chr"
	ENDM
ENDM

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                     C O N S T A N T S                                             
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.const
IDD_DIALOG			equ		1000
IDC_LISTVIEW		equ		1001
IDC_INPLACEEDIT		equ		1002
IDI_ICON			equ		2000
IDI_BITMAP			equ		2001

IDM_ABOUT			equ		3000

MAX_TEXT_LENGTH		equ		32
ID_LISTVIEW_TIMER	equ		3000
LVM_EDITSUBLABEL	equ		WM_USER+1

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              I N I T I A L I Z E D  D A T A                                       
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.data
g_szInPlaceEditClassName	db "InPlaceEdit", 0
szAbout						db "About...", 0
szWrittenBy					db "Written by Four-F ("
							date
							db ")", 0Ah, 0Dh, "four-f@mail.ru", 0

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              U N I N I T I A L I Z E D  D A T A                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.data?
g_hInstance				HINSTANCE	?
g_hListView				HWND		?
g_hImageList			HANDLE		?
g_pfnListViewProcPrev	LPVOID		?
g_hwndInPlaceEdit		HWND		?
g_lpfnPrevEditProc		LPVOID		?

g_iItem					UINT		?
g_iSubItem				UINT		?
g_pszInitText			LPSTR		?
g_fbUpdateText			BOOL		? ;	To indicate whether RETURN key was pressed

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                       C O D E                                                     
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.code

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

InPlaceEdit_OnChar proc hwndEdit:HWND, chCharCode:DWORD, lKeyData:ULONG

LOCAL acBuff[MAX_TEXT_LENGTH]:CHAR
LOCAL hwndParent:HWND
LOCAL hdc:HDC
LOCAL hfontOld:HFONT
LOCAL siz:_SIZE
LOCAL rect:RECT
LOCAL rcParent:RECT
LOCAL cb:UINT

	; Resize edit control if needed
	mov hwndParent, $invoke(GetParent, hwndEdit)

	; Get text extent
	mov cb, $invoke(GetWindowText, hwndEdit, addr acBuff, sizeof acBuff)
	mov hdc, $invoke(GetWindowDC, hwndEdit)
	mov hfontOld, $invoke(SelectObject, hdc, $invoke(SendMessage, hwndParent, WM_GETFONT, 0, 0))
	invoke GetTextExtentPoint32, hdc, addr acBuff, cb, addr siz	
	invoke SelectObject, hdc, hfontOld
	invoke ReleaseDC, hwndEdit, hdc

	add siz.x, 5				; add some extra buffer

	; Get client rect
	invoke GetClientRect, hwndEdit, addr rect
	invoke GetClientRect, hwndParent, addr rcParent

	; Transform rect to parent coordinates
	invoke MapWindowPoints, hwndEdit, hwndParent, addr rect, 2

	; Check whether control needs to be resized and whether there is space to grow
	mov eax, rect.right
	sub eax, rect.left					; Edit.width
	.if siz.x > eax						; Text.width > Edit.width ?
		mov eax, siz.x
		add eax, rect.left
		.if eax < rcParent.right
			mov rect.right, eax
		.else
			m2m rect.right, rcParent.right
		.endif
		; convert right, bottom -> width, height
		mov eax, rect.left
		sub rect.right, eax
		mov eax, rect.top
		sub rect.bottom, eax
		invoke MoveWindow, hwndEdit, rect.left, rect.top, rect.right, rect.bottom, TRUE
	.endif

	ret

InPlaceEdit_OnChar endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

InPlaceEdit_OnKillFocus proc uses esi hwndEdit:HWND, hwndGetFocus:HWND

LOCAL lvdi:LV_DISPINFO
LOCAL acBuff[MAX_TEXT_LENGTH]:CHAR
LOCAL hwndParent:HWND

	; Send Notification to parent of ListView ctrl
	lea esi, lvdi
	assume esi:ptr LV_DISPINFO
	mov hwndParent, $invoke(GetParent, hwndEdit)
	mov [esi].hdr.hwndFrom, eax
	mov [esi].hdr.idFrom, $invoke(GetDlgCtrlID, hwndEdit)
	mov [esi].hdr.code, LVN_ENDLABELEDIT

	mov [esi].item.imask, LVIF_TEXT
	m2m [esi].item.iItem, g_iItem
	m2m [esi].item.iSubItem, g_iSubItem
	
	.if g_fbUpdateText == TRUE
		invoke GetWindowText, hwndEdit, addr acBuff, sizeof acBuff
		lea eax, acBuff
	.else
		xor eax, eax
	.endif
	mov [esi].item.pszText, eax
	mov [esi].item.cchTextMax, sizeof acBuff

	mov edx, $invoke(GetParent, hwndParent)			; Main dialog hwnd
	invoke SendMessage, edx,  WM_NOTIFY, [esi].hdr.idFrom, addr lvdi
	assume esi:nothing

	invoke DestroyWindow, hwndEdit
	and g_hwndInPlaceEdit, 0
	invoke UnregisterClass, addr g_szInPlaceEditClassName, g_hInstance

	ret

InPlaceEdit_OnKillFocus endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

InPlaceEditProc proc hwndEdit:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL hdc:HDC
LOCAL siz:_SIZE

	mov eax, uMsg
	.if eax == WM_CREATE
		invoke CallWindowProc, g_lpfnPrevEditProc, hwndEdit, uMsg, wParam, lParam
		.if eax != -1
			push eax
			and g_fbUpdateText, FALSE
			; Set the proper font
			mov eax, lParam
			mov eax, (CREATESTRUCT PTR [eax]).hWndParent
			invoke SendMessage, eax, WM_GETFONT, 0, 0
			invoke SendMessage, hwndEdit, WM_SETFONT, eax, TRUE
			invoke SetFocus, hwndEdit
			invoke SendMessage, hwndEdit, EM_SETSEL, 0, -1
			;invoke SendMessage, hwndEdit, EM_SCROLLCARET, 0, 0
			pop eax
		.endif
		jmp @F

	.elseif eax == WM_CHAR
		invoke CallWindowProc, g_lpfnPrevEditProc, hwndEdit, uMsg, wParam, lParam
		push eax
		invoke InPlaceEdit_OnChar, hwndEdit, wParam, lParam
		pop eax
		jmp @F

	.elseif eax == WM_GETDLGCODE
		.if wParam == VK_RETURN
			mov g_fbUpdateText, TRUE
			invoke GetParent, hwndEdit
			invoke PostMessage, hwndEdit, WM_KILLFOCUS, eax, 0
			or eax, -1
			jmp @F
		.elseif wParam == VK_ESCAPE
			and g_fbUpdateText, FALSE
			invoke GetParent, hwndEdit
			invoke PostMessage, hwndEdit, WM_KILLFOCUS, eax, 0
			or eax, -1
			jmp @F
		.elseif wParam == VK_TAB
			or eax, -1
			jmp @F
		.endif

	.elseif eax == WM_KILLFOCUS
		invoke CallWindowProc, g_lpfnPrevEditProc, hwndEdit, uMsg, wParam, lParam
		push eax
		invoke InPlaceEdit_OnKillFocus, hwndEdit, wParam
		pop eax
		jmp @F

	.endif

	invoke CallWindowProc, g_lpfnPrevEditProc, hwndEdit, uMsg, wParam, lParam
@@:
   	ret

InPlaceEditProc endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

CreateInPlaceEdit proc dwStyle:DWORD, pRect:PTR RECT, hwndParent:HWND, uID:UINT

LOCAL wcx:WNDCLASSEX

	mov ecx, $TA0("Edit")
	mov wcx.cbSize, sizeof WNDCLASSEX
	invoke GetClassInfoEx, NULL, ecx, addr wcx
	m2m g_lpfnPrevEditProc, wcx.lpfnWndProc
	mov wcx.lpfnWndProc, offset InPlaceEditProc
	m2m wcx.hInstance, g_hInstance
	mov wcx.lpszClassName, offset g_szInPlaceEditClassName
	invoke RegisterClassEx, addr wcx

	mov edx, pRect
	assume edx:ptr RECT
	mov eax, [edx].left
	sub [edx].right, eax					; width
	mov eax, [edx].top
	sub [edx].bottom, eax					; height

	invoke CreateWindowEx, 0, addr g_szInPlaceEditClassName, g_pszInitText, dwStyle, \
					[edx].left, [edx].top, [edx].right, [edx].bottom, hwndParent, uID, g_hInstance, NULL
	assume edx:nothing

	ret							; return handle of new edit

CreateInPlaceEdit endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListCtrl_OnEditSubLabel proc uses esi edi hwndListView:HWND, nItem:UINT, nCol:UINT

; EditSubLabel	- Start edit of a sub item label
; Returns		- Temporary pointer to the new edit control
; nItem			- The row index of the item to edit
; nCol			- The column of the sub item.

LOCAL nColumnCount:UINT
LOCAL rect:RECT
LOCAL rcClient:RECT
LOCAL nOffset:UINT
LOCAL lvc:LV_COLUMN
LOCAL dwStyle:DWORD
LOCAL bRetFlag:BOOL
LOCAL cb:UINT

	and bRetFlag, FALSE
	; Make sure that the item is visible
	ListView_EnsureVisible hwndListView, nItem, FALSE

	.if eax == TRUE
		; Make sure that nCol is valid
		ListView_GetHeader hwndListView
		Header_GetItemCount eax
		mov nColumnCount, eax
		ListView_GetColumnWidth hwndListView, nCol
		mov edx, nColumnCount
		.if !( nCol >= edx || eax < 5 )
			; Get the column offset
			and nOffset, 0
			xor esi, esi
			.while esi < nCol					; for( int i = 0; i < nCol; i++ )
				ListView_GetColumnWidth hwndListView, esi
				add nOffset, eax
				inc esi
			.endw

			ListView_GetItemRect hwndListView, nItem, addr rect, LVIR_BOUNDS
			invoke GetClientRect, hwndListView, addr rcClient

			; Get Column alignment
			mov lvc.imask, LVCF_FMT
			ListView_GetColumn hwndListView, nCol, addr lvc
			mov eax, lvc.fmt
			and eax, LVCFMT_JUSTIFYMASK
			.if al == LVCFMT_LEFT
				mov dwStyle, ES_LEFT + WS_BORDER + WS_CHILD + WS_VISIBLE + ES_AUTOHSCROLL + WS_CLIPSIBLINGS
			.elseif al == LVCFMT_RIGHT
				mov dwStyle, ES_RIGHT + WS_BORDER + WS_CHILD + WS_VISIBLE + ES_AUTOHSCROLL + WS_CLIPSIBLINGS
			.else
				mov dwStyle, ES_CENTER + WS_BORDER + WS_CHILD + WS_VISIBLE + ES_AUTOHSCROLL + WS_CLIPSIBLINGS
			.endif

			mov esi, rect.left							; save

			mov eax, nOffset
			add eax, rect.left
			inc eax										; looks better

			assume eax:SDWORD
			.if eax < rcClient.left
				m2m rect.left, rcClient.left
			.else
				mov rect.left, eax
			.endif
			assume eax:SDWORD

			ListView_GetColumnWidth hwndListView, nCol
			add eax, nOffset
			add eax, esi

			assume eax:SDWORD
			.if eax > rcClient.right
				m2m rect.right, rcClient.right
			.else
				mov rect.right, eax
			.endif
			assume eax:SDWORD

			mov esi, $invoke(GetProcessHeap)
			mov g_pszInitText, $invoke(HeapAlloc, esi, HEAP_ZERO_MEMORY, MAX_TEXT_LENGTH)	; assume MAX_TEXT_LENGTH bytes is enought
			ListView_GetItemText hwndListView, nItem, nCol, g_pszInitText, MAX_TEXT_LENGTH

			invoke CreateInPlaceEdit, dwStyle, addr rect, hwndListView, IDC_INPLACEEDIT
			.if eax != NULL
				mov g_hwndInPlaceEdit, eax
				invoke PostMessage, g_hwndInPlaceEdit, EM_LIMITTEXT, MAX_TEXT_LENGTH-1, 0
				mov bRetFlag, TRUE
			.endif
			invoke HeapFree, esi, 0, g_pszInitText
		.endif
	.endif

	mov eax, bRetFlag
	ret

ListCtrl_OnEditSubLabel endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListCtrl_HitTestEx proc uses esi edi hwndListView:HWND, Point:DWORD, pColumn:LPVOID
; HitTestEx	- Determine the row index and column index for a point
; Returns	- the row index or -1 if point is not over a row
; pPoint	- point to be tested.
; pColumn	- to hold the column index

LOCAL uColnum:UINT
LOCAL uRow:UINT
LOCAL uBottom:UINT
LOCAL uColumnCount:UINT
LOCAL uColWidth:UINT
LOCAL rect:RECT
LOCAL lvhti:LV_HITTESTINFO
LOCAL dwRetVal:DWORD
LOCAL pt:POINT

	and uColnum, 0
	or dwRetVal, -1			; assume error

	mov eax, Point
	.if eax != NULL
		shr eax, 16
		mov pt.y, eax
		mov eax, Point
		and eax, 0FFFFh
		mov pt.x, eax

		.if pColumn != NULL			; do nothing if null pointer
			; Make sure that the ListView is in LVS_REPORT
			invoke GetWindowLong, hwndListView, GWL_STYLE
			and eax, LVS_TYPEMASK
			.if al != LVS_REPORT
				m2m lvhti.pt.x, pt.x
				m2m lvhti.pt.y, pt.y
				ListView_HitTest hwndListView, addr lvhti
				mov dwRetVal, eax				; return Row index

				mov eax, pColumn
				and DWORD PTR [eax], 0					; Col = 0
			.else
				; Get the top and bottom row visible
				ListView_GetTopIndex hwndListView
				mov uRow, eax
	
				ListView_GetCountPerPage hwndListView
				add eax, uRow
				mov uBottom, eax						; uBottom = uRow + GetCountPerPage()

				ListView_GetItemCount hwndListView
				.if uBottom > eax
					mov uBottom, eax					; uBottom = GetItemCount()
				.endif

				; Get the number of columns
				ListView_GetHeader hwndListView
				Header_GetItemCount eax
				mov uColumnCount, eax

				; Loop through the visible rows
				mov esi, uRow
				.while esi <= uBottom					; for( ; uRow <=bottom; uRow++)
					; Get bounding rect of item and check whether point falls in it.
					ListView_GetItemRect hwndListView, esi, addr rect, LVIR_BOUNDS

					invoke PtInRect, addr rect, pt.x, pt.y
					.if eax
						; Now find the column
						xor edi, edi					; colnum
						.while edi < uColumnCount		; for( colnum = 0; colnum < nColumnCount; colnum++ )
							ListView_GetColumnWidth hwndListView, edi
							mov uColWidth, eax
							mov eax, pt.x
							mov edx, rect.left
							assume eax:SDWORD
							assume edx:SDWORD
							.if eax >= edx
								add edx, uColWidth
								.if eax <= edx			; if( point.x >= rect.left && point.x <= (rect.left + uColWidth ) )
									mov eax, pColumn
									mov [eax], edi

									mov dwRetVal, esi	; return uRow
									or edi, -1		; to break outer while
									.break
								.endif
							assume eax:nothing
							assume edx:nothing
							.endif
							mov eax, uColWidth
							add rect.left, eax
							inc edi
						.endw
					.endif
					.break .if edi == -1
					inc esi
				.endw
			.endif
		.endif
	.endif

	mov eax, dwRetVal
	ret

ListCtrl_HitTestEx endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListCtrl_OnHScroll proc hwndListView:HWND, nScrollCode:UINT, nPos:UINT, hwndScrollBar:HWND

	invoke GetFocus
	.if eax != hwndListView
		; Return focus to ListView
		invoke SetFocus, hwndListView
	.endif

	ret

ListCtrl_OnHScroll endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListCtrl_OnVScroll proc hwndListView:HWND, nScrollCode:UINT, nPos:UINT, hwndScrollBar:HWND

	invoke GetFocus
	.if eax != hwndListView
		; Return focus to ListView
		invoke SetFocus, hwndListView
	.endif

	ret

ListCtrl_OnVScroll endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListCtrl_OnEndLabelEdit proc hwndListView:HWND, pNMHDR:PTR NMHDR

	mov esi, pNMHDR
	assume esi:ptr LV_DISPINFO
	.if [esi].item.pszText != NULL
		ListView_SetItemText hwndListView, [esi].item.iItem, [esi].item.iSubItem, [esi].item.pszText
	.endif
	assume esi:nothing

	ret

ListCtrl_OnEndLabelEdit endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListCtrl_TimerProc proc hwndListView:HWND, uMsg:UINT, idEvent:UINT, dwTime:DWORD

	invoke KillTimer, hwndListView, idEvent
	invoke PostMessage, hwndListView, LVM_EDITSUBLABEL, g_iItem, g_iSubItem

	ret

ListCtrl_TimerProc endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListCtrl_OnLButtonDown proc hwndListView:HWND, uKeys:UINT, Point:DWORD

LOCAL nRow:UINT
LOCAL nColumn:UINT

	invoke ListCtrl_HitTestEx, hwndListView, Point, addr nColumn
	.if eax != -1
		mov nRow, eax

		ListView_GetItemState hwndListView, nRow, LVIS_FOCUSED + LVIS_SELECTED
		.if ( eax == LVIS_FOCUSED + LVIS_SELECTED ) && ( g_hwndInPlaceEdit == NULL )
				m2m g_iItem, nRow
				m2m g_iSubItem, nColumn
				invoke SetTimer, hwndListView, ID_LISTVIEW_TIMER, 150, offset ListCtrl_TimerProc
		.else
			xor eax, eax
		.endif
	.endif

	ret

ListCtrl_OnLButtonDown endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListViewProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	.if eax == WM_LBUTTONDOWN
		invoke ListCtrl_OnLButtonDown, hWnd, wParam, lParam

	.elseif eax == WM_HSCROLL
		mov ecx, $LOWORD(wParam)
		invoke ListCtrl_OnHScroll, hWnd, ecx, $HIWORD(wParam), lParam
		xor eax, eax

	.elseif eax == WM_VSCROLL
		mov ecx, $LOWORD(wParam)
		invoke ListCtrl_OnVScroll, hWnd, ecx, $HIWORD(wParam), lParam
		xor eax, eax

	.elseif eax == LVM_EDITSUBLABEL
		invoke ListCtrl_OnEditSubLabel, hWnd, wParam, lParam

	.endif

	.if eax != TRUE		; don't call CallWindowProc if ListCtrl_OnLButtonDown returns TRUE
		invoke CallWindowProc, g_pfnListViewProcPrev, hWnd, uMsg, wParam, lParam
	.endif

	ret

ListViewProc endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ListViewInsert proc uses ebx hDlg:HWND

LOCAL rect:RECT
LOCAL lvc:LV_COLUMN
LOCAL lvi:LV_ITEM

	; Set Dialog Icon
	invoke LoadIcon, g_hInstance, IDI_ICON
	invoke SendMessage, hDlg, WM_SETICON, ICON_BIG, eax

	mov g_hListView, $invoke(GetDlgItem, hDlg, IDC_LISTVIEW)
	invoke SetFocus, g_hListView

	invoke GetClientRect, hDlg, addr rect
	invoke MoveWindow, g_hListView, rect.left, rect.top, rect.right, rect.bottom, FALSE

	ListView_SetExtendedListViewStyle g_hListView, LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT

	mov lvc.imask, LVCF_TEXT + LVCF_WIDTH 
	mov lvc.pszText, $TA0("Column1")
	mov lvc.lx, 80
	ListView_InsertColumn g_hListView, 0, addr lvc

	mov lvc.pszText, $TA0("Column2")
	or lvc.imask, LVCF_FMT
	mov lvc.fmt, LVCFMT_LEFT
	ListView_InsertColumn g_hListView, 1, addr lvc

	mov lvc.pszText, $TA0("Column3")
	mov lvc.fmt, LVCFMT_CENTER
	ListView_InsertColumn g_hListView, 2, addr lvc

	mov lvc.pszText, $TA0("Column4")
	mov lvc.fmt, LVCFMT_RIGHT
	ListView_InsertColumn g_hListView, 3, addr lvc

	push esi
	push edi
	mov esi, $invoke(ImageList_Create, 16, 16, ILC_COLOR24+ILC_MASK, 6, 0)
	mov edi, $invoke(LoadBitmap, g_hInstance, IDI_BITMAP)
	invoke ImageList_AddMasked, esi, edi, Magenta
	invoke DeleteObject, edi
	ListView_SetImageList g_hListView, esi, LVSIL_SMALL
	mov g_hImageList, esi
	pop edi
	pop esi

	mov lvi.imask, LVIF_TEXT + LVIF_IMAGE
	mov lvi.iItem, -1
	mov lvi.iImage, -1
	mov ebx, 3
	.while ebx

		inc lvi.iItem
		mov lvi.iSubItem, 0
		inc lvi.iImage
		mov lvi.pszText, $TA0("List-View")
		ListView_InsertItem g_hListView, addr lvi

		inc lvi.iSubItem
		mov lvi.pszText, $TA0("with")
		ListView_SetItem g_hListView, addr lvi

		inc lvi.iSubItem
		mov lvi.pszText, $TA0("editable")
		ListView_SetItem g_hListView, addr lvi

		inc lvi.iSubItem
		mov lvi.pszText, $TA0("subitems")
		ListView_SetItem g_hListView, addr lvi

		inc lvi.iItem
		mov lvi.iSubItem, 0
		inc lvi.iImage
		mov lvi.pszText, $TA0("Click")
		ListView_InsertItem g_hListView, addr lvi

		inc lvi.iSubItem
		mov lvi.pszText, $TA0("any")
		ListView_SetItem g_hListView, addr lvi

		inc lvi.iSubItem
		mov lvi.pszText, $TA0("subitem")
		ListView_SetItem g_hListView, addr lvi

		inc lvi.iSubItem
		mov lvi.pszText, $TA0("to edit")
		ListView_SetItem g_hListView, addr lvi

	dec ebx
	.endw

	mov g_pfnListViewProcPrev, $invoke(SetWindowLong, g_hListView, GWL_WNDPROC, offset ListViewProc)

	ret

ListViewInsert endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                 D I A L O G      P R O C E D U R E                                
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgProc proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	.if eax == WM_NOTIFY
		mov eax, lParam
		mov eax, (NMHDR ptr [eax]).hwndFrom
		.if eax == g_hListView
			; Notify message from ListView
			mov eax, lParam
			assume eax:PTR NMHDR
			.if [eax].code == LVN_ENDLABELEDIT
				invoke ListCtrl_OnEndLabelEdit, g_hListView, eax
			.endif
			assume eax:nothing
		.endif

	.elseif eax == WM_COMMAND
		mov eax, wParam
		and eax, 0FFFFh
		.if eax == IDCANCEL
			invoke EndDialog, hDlg, 0
		.endif

	.elseif eax == WM_SYSCOMMAND
		.if wParam == IDM_ABOUT
			invoke MessageBox, hDlg, addr szWrittenBy, addr szAbout, MB_OK + MB_ICONINFORMATION
		.endif
 		xor eax, eax
 		ret

	.elseif eax == WM_INITDIALOG
		push ebx
		invoke GetSystemMenu, hDlg, FALSE
		mov ebx, eax
		invoke InsertMenu, ebx, -1, MF_BYPOSITION + MF_SEPARATOR, 0, 0
		invoke InsertMenu, ebx, -1, MF_BYPOSITION + MF_STRING, IDM_ABOUT, offset szAbout
		pop ebx

		invoke ListViewInsert, hDlg

	.elseif eax == WM_DESTROY
		invoke ImageList_Destroy, g_hImageList

	.else
		xor eax, eax
		ret
	
	.endif

	xor eax, eax
	inc eax
	ret
    
DlgProc endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

start:
	mov g_hInstance, $invoke(GetModuleHandle, NULL)
	invoke DialogBoxParam, g_hInstance, IDD_DIALOG, NULL, addr DlgProc, 0
	invoke ExitProcess, 0
	invoke InitCommonControls
end start
