; Written by Four-F (four-f@mail.ru)

.386
.model flat, stdcall
option casemap:none

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                  I N C L U D E   F I L E S                                        
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

include \masm32\include\windows.inc

include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

include \masm32\cocomac\cocomac.mac
include \masm32\cocomac\TabCtrl.mac

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                 S T R U C T U R E S                                               
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

_TC_ITEM STRUCT
  imask             DWORD      ?

  dwState           DWORD      ?  ; defined as lpReserved1 in windows.inc (1.25a) !!!
  dwStateMask       DWORD      ?  ; defined as lpReserved2 windows.inc (1.25a) !!!

  pszText           DWORD      ?
  cchTextMax        DWORD      ?
  iImage            DWORD      ?
  lParam            DWORD      ?
_TC_ITEM ENDS

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                         F U N C T I O N S   P R O T O T Y P E S                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgProc proto :HWND, :UINT, :WPARAM, :LPARAM

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                     C O N S T A N T S                                             
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.const
IDD_DIALOG			equ	1000
IDD_DIALOG1			equ 1001
IDD_DIALOG2			equ 1002
IDD_DIALOG3			equ 1003
IDD_DIALOG4			equ 1004
IDD_DIALOG5			equ 1005
IDC_TAB				equ 1010

IDC_GROUP1			equ 1021
IDC_GROUP2			equ 1022
IDC_GROUP3			equ 1023
IDC_GROUP4			equ 1024
IDC_GROUP5			equ 1025

IDI_ICON			equ	2000
IDI_STAR_ICON		equ	2001
IDI_SLEEP_ICON		equ	2002
IDI_SHUTDOWN_ICON	equ 2003
IDI_LOGOFF_ICON		equ 2004
IDI_HELP_ICON		equ 2005
IDI_BITMAP			equ 2006

NUMTABS				equ	5

ASCENT				equ	24			; from top of dialog

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              I N I T I A L I Z E D  D A T A                                       
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.data
szTab1					db "Next", 0
szTab2					db "Stop", 0
szTab3					db "Home", 0
szTab4					db "Tools", 0
szTab5					db "Settings", 0
g_apTabsTitel			dd offset szTab1
						dd offset szTab2
						dd offset szTab3
						dd offset szTab4
						dd offset szTab5

szWrittenBy				db "Written by Four-F", 0
szMail					db "four-f@mail.ru", 0
szFontName				db "Verdana", 0

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              U N I N I T I A L I Z E D  D A T A                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.data?
g_hInstance				HINSTANCE	?
g_hwndTab				HWND		?
g_hImageList			HANDLE		?
g_pfnTabCtrlProcPrev	LPVOID		?
g_iTabPrev				UINT		?
g_hLogoFont				HFONT		?
g_ahTabDlg				HWND		NUMTABS dup(?)

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                       C O D E                                                     
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.code

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

TabCtrlProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL tchti:TC_HITTESTINFO
LOCAL tci:_TC_ITEM
LOCAL iTabCur:UINT

LOCAL rect:RECT
LOCAL hdc:HDC
LOCAL ps:PAINTSTRUCT 
LOCAL hOldFont:HFONT
LOCAL ts:_SIZE
LOCAL hbrhBlack:HBRUSH

	mov eax, uMsg
	.if eax == WM_NCHITTEST

		mov eax, lParam
		and eax, 0FFFFh
		mov tchti.pt.x, eax			; horizontal position of cursor

		mov eax, lParam
		shr eax, 16
		mov tchti.pt.y, eax			; vertical position of cursor

		invoke ScreenToClient, hWnd, addr tchti.pt

		TabCtrl_HitTest hWnd, addr tchti
		.if ( eax != -1 ) && ( eax != g_iTabPrev )
			mov iTabCur, eax

			mov tci.imask, TCIF_STATE
			mov tci.dwStateMask, TCIS_BUTTONPRESSED
			TabCtrl_GetItem g_hwndTab, iTabCur, addr tci
			.if tci.dwState != TCIS_BUTTONPRESSED	; don't process pressed button
				; restore gray image
				mov tci.imask, TCIF_IMAGE
				mov eax, g_iTabPrev
				mov tci.iImage, eax
				TabCtrl_SetItem g_hwndTab, g_iTabPrev, addr tci

				; set color image
				mov eax, iTabCur
				mov g_iTabPrev, eax					; update
				add eax, NUMTABS
				mov tci.iImage, eax
				TabCtrl_SetItem g_hwndTab, iTabCur, addr tci
			.endif
		.endif

	.elseif eax == WM_MOUSELEAVE
		mov tci.imask, TCIF_STATE
		mov tci.dwStateMask, TCIS_BUTTONPRESSED
		TabCtrl_GetItem g_hwndTab, g_iTabPrev, addr tci
		.if tci.dwState != TCIS_BUTTONPRESSED	; don't process pressed button
			; restore gray image
			mov tci.imask, TCIF_IMAGE
			mov eax, g_iTabPrev
			mov tci.iImage, eax
			TabCtrl_SetItem g_hwndTab, g_iTabPrev, addr tci
		.endif
		or g_iTabPrev, -1

	.endif

	invoke CallWindowProc, g_pfnTabCtrlProcPrev, hWnd, uMsg, wParam, lParam
	ret

TabCtrlProc endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

AdjustDialog proc hDlg:HWND, hGroup:HWND

LOCAL rect:RECT
LOCAL hTab:HWND

	invoke GetParent, hDlg
	mov hTab, eax
	invoke GetWindowRect, hTab, addr rect
	TabCtrl_AdjustRect hTab, FALSE, addr rect
	mov eax, rect.left
	sub rect.right, eax
	mov eax, rect.top
	sub rect.bottom, eax
	invoke ScreenToClient, hDlg, addr rect
	invoke MoveWindow, hDlg, rect.left, rect.top, rect.right, rect.bottom, FALSE
	invoke MoveWindow, hGroup, 0, 0, rect.right, rect.bottom, FALSE

	ret

AdjustDialog endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

TabProc1 proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	.if eax == WM_INITDIALOG
		invoke GetDlgItem, hDlg, IDC_GROUP1
		invoke AdjustDialog, hDlg, eax
	.else
		xor eax, eax
		ret
	.endif

	xor eax, eax
	inc eax
	ret

TabProc1 endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

TabProc2 proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	.if eax == WM_INITDIALOG
		invoke GetDlgItem, hDlg, IDC_GROUP2
		invoke AdjustDialog, hDlg, eax

	.elseif eax == WM_COMMAND
		mov eax, wParam
		and eax, 0FFFFh
		.if eax == IDCANCEL
			invoke GetParent, hDlg
			invoke GetParent, eax				; main dialog
			invoke PostMessage, eax, WM_COMMAND, IDCANCEL, 0
		.endif

	.else
		xor eax, eax
		ret
	.endif

	xor eax, eax
	inc eax
	ret

TabProc2 endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

TabProc3 proc uses ebx hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL hdc:HDC
LOCAL ps:PAINTSTRUCT 
LOCAL hOldFont:HFONT
LOCAL ts:_SIZE
LOCAL hbrBlack:HBRUSH
LOCAL rect:RECT

	mov eax, uMsg
	.if eax == WM_INITDIALOG
		invoke GetDlgItem, hDlg, IDC_GROUP3
		invoke AdjustDialog, hDlg, eax

	.elseif eax == WM_PAINT

		invoke BeginPaint, hDlg, addr ps
		mov hdc, eax

		invoke SelectObject, hdc, g_hLogoFont
		mov hOldFont, eax

		invoke GetStockObject, BLACK_BRUSH
		mov hbrBlack, eax

		invoke GetTextExtentPoint32, hdc, addr szWrittenBy, (sizeof szWrittenBy)-1, addr ts

		invoke GetClientRect, hDlg, addr rect
		mov eax, rect.right
		sub eax, rect.left				; dialog width
		sub eax, ts.x
		shr eax, 1
		dec eax
		invoke DrawState, hdc, NULL, NULL, addr szWrittenBy, 0, eax, ASCENT, ts.x, ts.y, DSS_DISABLED + DST_TEXT


		invoke GetTextExtentPoint32, hdc, addr szMail, (sizeof szMail)-1, addr ts

		invoke GetClientRect, hDlg, addr rect
		mov eax, rect.right
		sub eax, rect.left				; dialog width
		sub eax, ts.x
		shr eax, 1
		dec eax
		invoke DrawState, hdc, NULL, NULL, addr szMail, 0, eax, ASCENT*3, ts.x, ts.y, DSS_DISABLED + DST_TEXT


		invoke SelectObject, hdc, hOldFont
		invoke EndPaint, hDlg, addr ps

	.else
		xor eax, eax
		ret
	.endif

	xor eax, eax
	inc eax
	ret

TabProc3 endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

TabProc4 proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	.if eax == WM_INITDIALOG
		invoke GetDlgItem, hDlg, IDC_GROUP4
		invoke AdjustDialog, hDlg, eax
	.else
		xor eax, eax
		ret
	.endif

	xor eax, eax
	inc eax
	ret

TabProc4 endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

TabProc5 proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	.if eax == WM_INITDIALOG
		invoke GetDlgItem, hDlg, IDC_GROUP5
		invoke AdjustDialog, hDlg, eax
	.else
		xor eax, eax
		ret
	.endif

	xor eax, eax
	inc eax
	ret

TabProc5 endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              D I A L O G      P R O C E D U R E                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgProc proc uses ebx hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL rect:RECT
LOCAL tci:_TC_ITEM
;LOCAL hbmp:HBITMAP

	mov eax, uMsg
	.if eax == WM_INITDIALOG

		; Set Dialog Icon
		invoke LoadIcon, g_hInstance, IDI_ICON
		invoke SendMessage, hDlg, WM_SETICON, ICON_BIG, eax

		; Get the dimensions of the parent window's client area
		invoke GetClientRect, hDlg, addr rect
		invoke GetDlgItem, hDlg, IDC_TAB
		mov g_hwndTab, eax
		invoke MoveWindow, g_hwndTab, 0, 0, rect.right, rect.bottom, FALSE

		invoke ImageList_Create, 16, 16, ILC_COLOR24 + ILC_MASK, NUMTABS*2, 0
		mov g_hImageList, eax
		invoke LoadBitmap, g_hInstance, IDI_BITMAP
		push eax
		invoke ImageList_AddMasked, g_hImageList, eax, Magenta
		call DeleteObject
		TabCtrl_SetImageList g_hwndTab, g_hImageList

		; Add tabs
		mov tci.imask, TCIF_TEXT + TCIF_IMAGE
		xor ebx, ebx
		.while ebx < NUMTABS
			mov tci.iImage, ebx
			mov eax, g_apTabsTitel[ebx * sizeof LPSTR]
			mov tci.pszText, eax
			TabCtrl_InsertItem g_hwndTab, ebx, addr tci
			inc ebx
		.endw

		; first button is pressed by default
		; set color image
		mov tci.imask, TCIF_IMAGE
		mov tci.iImage, NUMTABS
		TabCtrl_SetItem g_hwndTab, 0, addr tci

		; subclass tab control to have possibility receive WM_NCHITTEST message
		invoke SetWindowLong, g_hwndTab, GWL_WNDPROC, addr TabCtrlProc
		mov g_pfnTabCtrlProcPrev, eax

		or g_iTabPrev, -1

		; Create tab's dialogs
		invoke CreateDialogParam, g_hInstance, IDD_DIALOG1, g_hwndTab, addr TabProc1, 0
		mov g_ahTabDlg[0*(sizeof HWND)], eax
		invoke ShowWindow, eax, SW_SHOWDEFAULT

		invoke CreateDialogParam, g_hInstance, IDD_DIALOG2, g_hwndTab, addr TabProc2, 0
		mov g_ahTabDlg[1*(sizeof HWND)], eax
		invoke ShowWindow, eax, SW_HIDE

		invoke CreateDialogParam, g_hInstance, IDD_DIALOG3, g_hwndTab, addr TabProc3, 0
		mov g_ahTabDlg[2*(sizeof HWND)], eax
		invoke ShowWindow, eax, SW_HIDE

		invoke CreateDialogParam, g_hInstance, IDD_DIALOG4, g_hwndTab, addr TabProc4, 0
		mov g_ahTabDlg[3*(sizeof HWND)], eax
		invoke ShowWindow, eax, SW_HIDE

		invoke CreateDialogParam, g_hInstance, IDD_DIALOG5, g_hwndTab, addr TabProc5, 0
		mov g_ahTabDlg[4*(sizeof HWND)], eax
		invoke ShowWindow, eax, SW_HIDE


		invoke CreateFont, -20, 0, 0, 0, FW_BOLD, TRUE, FALSE, 0, 0, 0, 0, 0, 0, addr szFontName
		mov g_hLogoFont, eax

	.elseif eax == WM_NOTIFY
		mov eax, lParam
		.if ( wParam == IDC_TAB ) && ( [NMHDR ptr [eax]].code == TCN_SELCHANGE )
			TabCtrl_GetCurSel g_hwndTab
			; set color image
			mov tci.imask, TCIF_IMAGE
			mov ecx, eax
			add eax, NUMTABS
			mov tci.iImage, eax
			; Show tab dialog
			invoke ShowWindow, [g_ahTabDlg][ecx*(sizeof HWND)], SW_SHOWDEFAULT

			TabCtrl_SetItem g_hwndTab, ecx, addr tci
		.elseif ( wParam == IDC_TAB ) && ( [NMHDR ptr [eax]].code == TCN_SELCHANGING )
			TabCtrl_GetCurSel g_hwndTab
			; restore gray image
			mov tci.imask, TCIF_IMAGE
			mov tci.iImage, eax
			; Hide tab dialog
			invoke ShowWindow, [g_ahTabDlg][eax*(sizeof HWND)], SW_HIDE
			TabCtrl_SetItem g_hwndTab, tci.iImage, addr tci
		.endif

	.elseif eax == WM_COMMAND

		mov eax, wParam
		and eax, 0FFFFh
		.if eax == IDCANCEL
			invoke EndDialog, hDlg, 0
		.endif

	.elseif eax == WM_DESTROY
		invoke ImageList_Destroy, g_hImageList
		invoke DeleteObject, g_hLogoFont

	.else

 		xor eax, eax
 		ret

	.endif

	xor eax, eax
	inc eax
	ret   
    
DlgProc endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

start:
	invoke GetModuleHandle, NULL
	mov g_hInstance, eax
	invoke DialogBoxParam, g_hInstance, IDD_DIALOG, NULL, addr DlgProc, 0
	invoke ExitProcess, eax
    invoke InitCommonControls
end start